"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.asyncUpdatingLatestVersionOfNpms = exports.updatingGatewayJson = exports.fixVariousCodeSegment = exports.copyWriterTs = exports.generateDefaultTest = exports.processCodes = exports.renameJs2Ts = exports.removeNodeModules = exports.copyBasicConfigFiles = exports.generateCode = exports.fixUsingLint = exports.installNpm = exports.getCodegenLocation = exports.getLatestNPMVersions = exports.setFileLocation = exports.getFileLocation = exports.setIndexTsAndServiceCode = exports.setPackageName = void 0;
const YAML = __importStar(require("yaml"));
const fs = __importStar(require("fs"));
const shelljs_1 = __importDefault(require("shelljs"));
const lodash_1 = __importDefault(require("lodash"));
const log4js = __importStar(require("log4js"));
const package_json_1 = __importDefault(require("package-json"));
const data_1 = require("./data");
const logger = log4js.getLogger();
logger.level = 'DEBUG';
const { exec, cp, rm, find, mv, env, sed, cd, mkdir, cat, } = shelljs_1.default;
const { cloneDeep } = lodash_1.default;
let fileLocation = null;
function setPackageName(fileName, destination) {
    const nameList = fileName.split('/');
    const lastNameList = nameList[nameList.length - 1].split('.');
    const lastName = lastNameList[0];
    const elementList = lastName.split('-');
    const domain = elementList[1];
    let appTemp = '';
    // eslint-disable-next-line no-plusplus
    for (let i = 3; i < elementList.length; i++) {
        appTemp += `${elementList[i]}-`;
    }
    const app = appTemp.slice(0, -1);
    const list = fs.readdirSync(`${destination}/service`);
    let targetFileName;
    list.forEach((filename) => {
        if (filename !== 'HealthCheckService.ts') {
            targetFileName = filename.split('.');
        }
    });
    const serviceName = `${targetFileName[0]}.ts`;
    sed('-i', 'REPLACE_WITH_NAME', lastName, `${destination}/package.json`);
    sed('-i', 'REPLACE_WITH_DOMAIN', domain, `${destination}/service/${serviceName}`);
    sed('-i', 'REPLACE_WITH_AP', app, `${destination}/service/${serviceName}`);
}
exports.setPackageName = setPackageName;
function setIndexTsAndServiceCode(destination) {
    const list = fs.readdirSync(`${destination}/service`);
    let targetFileName;
    list.forEach((filename) => {
        if (filename !== 'HealthCheckService.ts') {
            targetFileName = filename.split('.');
        }
    });
    const serviceName = `${targetFileName[0]}.ts`;
    sed('-i', 'REPLACE_WITH_SERVICE', targetFileName[0], `${destination}/index.ts`);
    cat(`${fileLocation}/codegen/files/head-of-service`).cat(`${destination}/service/${serviceName}`).to(`${destination}/service/${serviceName}`);
}
exports.setIndexTsAndServiceCode = setIndexTsAndServiceCode;
function getFileLocation() {
    return fileLocation;
}
exports.getFileLocation = getFileLocation;
function setFileLocation(data) {
    fileLocation = data;
}
exports.setFileLocation = setFileLocation;
function getLatestNPMVersions(packageJSON) {
    return __awaiter(this, void 0, void 0, function* () {
        const myPackageJSON = cloneDeep(packageJSON);
        try {
            const keyList = Object.keys(myPackageJSON.dependencies);
            const result = [];
            keyList.forEach((element) => {
                result.push((0, package_json_1.default)(element));
            });
            const myResult = yield Promise.all(result);
            myPackageJSON.dependencies = {};
            myResult.forEach((element) => {
                myPackageJSON.dependencies[element.name] = `^${element.version}`;
            });
            const keyListDev = Object.keys(myPackageJSON.devDependencies);
            const resultDev = [];
            keyListDev.forEach((element) => {
                resultDev.push((0, package_json_1.default)(element));
            });
            const myResultDev = yield Promise.all(resultDev);
            myPackageJSON.devDependencies = {};
            myResultDev.forEach((element) => {
                // if (element.name === 'jest') {
                //   myPackageJSON.devDependencies[element.name] = '28.1.3';
                // } else {
                myPackageJSON.devDependencies[element.name] = `^${element.version}`;
                // }
            });
            return myPackageJSON;
        }
        catch (ex) {
            return ex;
        }
    });
}
exports.getLatestNPMVersions = getLatestNPMVersions;
function getCodegenLocation() {
    return env.CODEGEN;
}
exports.getCodegenLocation = getCodegenLocation;
function installNpm(destination) {
    cd(destination);
    exec('npm install');
}
exports.installNpm = installNpm;
function fixUsingLint(destination) {
    cd(destination);
    exec('npx eslint --fix service/* > /dev/null');
}
exports.fixUsingLint = fixUsingLint;
function generateCode(fileName, destination) {
    if (exec(`java -jar ${fileLocation}/codegen/swagger-codegen-cli.jar generate -i ${fileName} -l nodejs-server -o ${destination}`).code !== 0) {
        logger.error('Codegen error');
        process.exit(-1);
    }
}
exports.generateCode = generateCode;
function copyBasicConfigFiles(destination) {
    const sourcePath = `${fileLocation}/codegen/files`;
    data_1.configFiles.forEach((element) => {
        if (element === 'gitignore') {
            if (cp(`${sourcePath}/${element}`, `${destination}/.gitignore`).code !== 0) {
                logger.error(`Copy error of ${element}`);
                process.exit(-1);
            }
        }
        else if (cp(`${sourcePath}/${element}`, destination).code !== 0) {
            logger.error(`Copy error of ${element}`);
            process.exit(-1);
        }
    });
}
exports.copyBasicConfigFiles = copyBasicConfigFiles;
function removeNodeModules(destination) {
    rm('-rf', `${destination}/node_modules`);
}
exports.removeNodeModules = removeNodeModules;
function renameJs2Ts(destination) {
    const fileList = find(destination).filter((file) => file.match(/\.js$/));
    fileList.forEach((element) => {
        mv(element, element.replace(/.js$/, '.ts'));
    });
}
exports.renameJs2Ts = renameJs2Ts;
function processCodes(destination) {
    const fileList = find(destination).filter((file) => file.match(/\.ts$/));
    fileList.forEach((element) => {
        sed('-i', '= function', '', element);
        sed('-i', 'exports.', 'export async function ', element);
        sed('-i', '\'use strict\';', '', element);
        sed('-i', '(\\s+([a-zA-Z]+\\s+)+)Promise\\(function\\(resolve, reject\\) \\{', '', element);
        sed('-i', '  \\}\\);', '', element);
        sed('-i', 'resolve\\(', 'return(', element);
        sed('-i', 'return\\(\\)', 'return null', element);
        sed('-i', '  var examples = \\{\\};', '', element);
        sed('-i', 'examples\\[\'application/json\']', 'const examples', element);
        sed('-i', '\\(examples\\[Object\\.keys\\(examples\\)\\[0]]\\)', ' examples', element);
    });
}
exports.processCodes = processCodes;
function generateDefaultTest(destination) {
    mkdir(`${destination}/__tests__`);
    const src = `${fileLocation}/codegen/files/__tests__/Default.test.ts`;
    const dest = `${destination}/__tests__/Default.test.ts`;
    cp(src, dest);
}
exports.generateDefaultTest = generateDefaultTest;
function copyWriterTs(destination) {
    const src = `${fileLocation}/codegen/files/utils/writer.ts`;
    const dest = `${destination}/utils/writer.ts`;
    cp(src, dest);
}
exports.copyWriterTs = copyWriterTs;
function fixVariousCodeSegment(destination) {
    data_1.sedFiles.forEach((element) => {
        if (element.command.type === 'sed') {
            sed(element.command.params[0], element.command.params[1], element.command.params[2], `${destination}/${element.file}`);
        }
    });
    const fileList2 = find(`${destination}/service`).filter((file) => file.match(/\.ts$/));
    fileList2.forEach((element) => {
        sed('-i', ' resolve();', ' resolve(null);', element);
    });
}
exports.fixVariousCodeSegment = fixVariousCodeSegment;
function updatingGatewayJson(destination) {
    const file = fs.readFileSync(`${destination}/api/openapi.yaml`, 'utf8');
    const result = YAML.parse(file);
    const pathList = [];
    const methodList = [];
    Object.keys(result.paths).forEach((element) => {
        if (element !== '/health-check') {
            pathList.push(element);
            Object.keys(result.paths[element]).forEach((subElement) => {
                if (!methodList.includes(subElement)) {
                    methodList.push(subElement.toUpperCase());
                }
            });
        }
    });
    const outputData = {
        type: 'external',
        paths: pathList,
        methods: methodList,
        regex_priority: 2,
    };
    const outString = JSON.stringify(outputData, null, 2);
    fs.writeFileSync(`${destination}/gateway.json`, outString);
}
exports.updatingGatewayJson = updatingGatewayJson;
function asyncUpdatingLatestVersionOfNpms(destination) {
    return __awaiter(this, void 0, void 0, function* () {
        const targetData = fs.readFileSync(`${destination}/package.json`, 'utf8');
        const targetJson = JSON.parse(targetData);
        const solvedTargetJSON = yield getLatestNPMVersions(targetJson);
        const targetFileContent = JSON.stringify(solvedTargetJSON, null, 2);
        fs.writeFileSync(`${destination}/package.json`, targetFileContent);
    });
}
exports.asyncUpdatingLatestVersionOfNpms = asyncUpdatingLatestVersionOfNpms;
//# sourceMappingURL=tools.js.map